
import java.awt.*;
import javax.swing.*;

public class Ej1 extends JFrame {

	public final static String TEXTO = "Este texto debe poderse ver perfectamente sin parpadeos.";

	public Ej1() {

		// Establece las dimensiones de la ventana
		setSize(200,100);

		// Crea el area de dibujo que hemos definido
		AreaDibujo area = new AreaDibujo();
		getContentPane().add(area, BorderLayout.CENTER);

		// Cuando cerremos la ventana saldr de la aplicacin
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}

	class AreaDibujo extends Canvas implements Runnable {

		// Fuente y mtricas
		Font f;
		FontMetrics fm;

		// Imagen que har de backbuffer
		Image backbuffer = null;

		// Ancho y alto del componente
		int w, h;

		// Posicion del texto
		int x, y;

		// Hilo para la animacin
		Thread t;

		public AreaDibujo() {

			// Crea la fuente y obtiene sus metricas
			f = new Font("Arial", Font.PLAIN, 20);
			fm = getFontMetrics(f);

			// Ejecuta el hilo para la animacion
			t = new Thread(this);
			t.start();
		}

		/* Necesitamos sobrescribir algun otro metodo para evitar el parpadeo? */

		public void paint(Graphics g) {

			// Si no hay backbuffer o el area ha cambiado de tamao
			// volvemos a crear el backbuffer y a establecer las coordenadas

			if(w!=getWidth() || h!=getHeight() /* || o no hay backbuffer */ ) {
				w = getWidth();
				h = getHeight();
				x = w;
				y = h - 10;

				/* Crear el backbuffer */
			}

			/* Obtener contexto grfico del backbuffer */
	
			// Dibuja el texto (cambiar para dibujar en backbuffer)
			g.setFont(f);
			g.setColor(Color.black);
			g.drawString(TEXTO, x, y);
	
			/* Vuelca el backbuffer a pantalla */
		}

		public void run() {
			while(t == Thread.currentThread()) {

				// Desplaza el texto a la izquierda
				x--;
	
				// Si ha desaparecido completamente vuelve a la derecha
				if(x < -fm.stringWidth(TEXTO)) {
					x = getWidth();
				}
	
				// Solicitamos que se repinte el nuevo frame
				repaint();
	
				try {
					Thread.currentThread().sleep(10);
				} catch(InterruptedException e) {}
			}
		}

	}

	public static void main(String [] args) {
		Ej1 ej1 = new Ej1();

		ej1.show();
	}

}